#include <gtk/gtk.h>
#include <stdio.h>
#include <time.h>
#include "iconos.xpm"

#define NUMCAMPOS 20
#define NUMDB 2

FILE *pfdb[NUMDB];
char nombredb[80*NUMDB];
unsigned char cabecera[35];
unsigned char  *cabememo[NUMDB];
unsigned int totalcampos[NUMDB],primercampo[NUMDB];
unsigned int tamaregs[NUMDB],numreg[NUMDB];
long tamano[NUMDB];
char tamareg[1000][NUMDB];


void on_guardar(void);
void on_salir(void);
void on_aceptar(void);
void on_borrar(void);

void menos_button10(void);
void mas_button11(void);
void inicio_button6_clicked(void);
void fin_button7_clicked(void);
void menos10_button8_clicked(void);
void mas10_button9_clicked (void);
void on_entry2_activate (void);
void on_entry3_activate (void);
void on_Buscar_clicked(void);
void on_Siguiente_clicked(void);
void on_ebuscar_activate(void);
void on_combo_entry1_changed(void);


void on_button5_clicked (void);
void on_button6_clicked (void);
void on_button20_clicked (void);
void on_button21_clicked (void);
void on_button22_clicked (void);
void on_button23_clicked (void);
void on_button24_clicked (void);

void on_button25_clicked(void);
void on_button26_clicked (void);

void on_button28_clicked(void);
void on_button29_clicked(void);
void MenuOrdenar(void);
void on_combo_entry3_changed(void);

GtkAccelGroup *accel_group;
GtkWidget  *window, *filew, *text,*toolbar;
GtkTooltips *tooltips;

GtkWidget *window2;
GtkWidget *clist1;
GtkWidget *clist2;
GtkWidget *entry1;
GtkWidget *entry2;
GtkWidget *entry3;
GtkWidget *entry4;
GtkWidget *entry5;
GtkWidget *entry6;

GtkWidget *bcampo;
GtkWidget *combo_entry2;
GtkWidget *combo1;
GList *combo1_items = NULL;
GList *combo3_items = NULL;
GtkWidget *combo_entry1;

GtkWidget *spinbutton2;
GtkWidget *spinbutton3;
void on_row( GtkWidget  *clist,gint  row, gint column,
			GdkEventButton *event, gpointer data );

GtkWidget *window3;
GtkWidget *vbox12;
GtkWidget *vbox13;
GtkWidget *entrynom[NUMCAMPOS];
GtkWidget *entryval[NUMCAMPOS];

/* variables de la pantalla ordenar */
	GtkWidget *window4;
	GtkWidget *combo4;
  	GtkWidget *combo_entry3;
	GList *combo4_items = NULL;

#include "interface.c"


char VARI[80],buffer[1024],nombrefichero[256]="Sin_nombre";
FILE *pf;
unsigned int z,zz,zrow,t,tt,i,vx,vy;
int yy,yyz,yyz1,yyz2,forma;
unsigned char *ppv,*ppv1,*pun;



int opendb(char *nombre,int numdb);
int closedb(int numdb);
void verficha(int num,int numdb);
int compara(int numdb,int num,int campo,char *texto);
int SearchAll(int n,char *texto);
void appedb(int numdb);
void deldb(int num,int numdb);
void nodeldb(int num,int numdb);
void packdb(int numdb);
char verdeldb(int num,int numdb);
void ordenardb(int num,int numdb,int forma);
void MinuMayu(int numdb);

gint salir (GtkWidget *widget,gpointer gdata);
static void vermenu(gpointer callback_data,guint callback_action,GtkWidget *widget);
void MenuLoad(void);
void LoadOk( GtkWidget *w, GtkFileSelection *fs);
void MenuSave(void);
void CopiaDia(void);
void SaveAsOk( GtkWidget *w, GtkFileSelection *fs);
void MenuNew(void);
void MenuBuscar(void);
void MenuOrdenar1(void);
void MenuOrdenar2(void);
void MenuMiMa(void);

void MenuAbout(void);
void CuadroOk(char *titulo,char *texto,char *imagen);
void CloseDialogo(GtkWidget *widget,gpointer data);
void CreateText(GtkWidget *container);
void CreateBar(GtkWidget *container);
GtkWidget *CreateWidgetFromXpm(GtkWidget *win,gchar **xpm_data);

static void salirmenu(gpointer callback_data,guint callback_action,GtkWidget *widget)
{
   gtk_main_quit();
}

static GtkItemFactoryEntry menu_items[]=
   {
    {"/_Archivo",		NULL,		0,		0,	"<Branch>"},
    {"/Archivo/Nuevo",	"<control>N",	MenuNew,	0,		},
    {"/Archivo/Abrir",	"F3",	MenuLoad,	0,		},
	{"/Archivo/Guardar",	"F2",	MenuSave,	0,		},
	{"/Archivo/Copia Seguridad Dia",	NULL,	CopiaDia,	0,		},
    {"/Archivo/sep1",	NULL,		vermenu,	0,	"<Separator>"},
    {"/Archivo/Salir",	"<control>X",	salirmenu,		0,		},

	{"/_Editar",		NULL,		0,		0,	"<Branch>"},
    {"/Editar/Buscar",	"F4",	MenuBuscar,	0,		},
	{"/Editar/Minusculas->Mayuscula",	0,	MenuMiMa,	0,		},

	{"/_Ordenar",		NULL,		0,		0,	"<Branch>"},
 	{"/Ordenar/Ordenar Ascendente",	"F5",	MenuOrdenar1,	0,		},
 	{"/Ordenar/Ordenar Descendente",	0,	MenuOrdenar2,	0,		},

    {"/Ayuda",		NULL,		0,		0,	"<LastBranch>"},
   {"/Ayuda/Acerca",	NULL,		MenuAbout,	0,		},
   };
static int nmenu_items=sizeof(menu_items)/sizeof(menu_items[0]);

static void vermenu(gpointer callback_data,guint callback_action,GtkWidget *widget)
{
 g_print("ItemFactory: activated %s action %d", gtk_item_factory_path_from_widget(widget),(guint) callback_action);
}

static void CreateItemFactory()
{
  GtkWidget *box1;
  GtkAccelGroup *accel_group;
  GtkItemFactory *item_factory;

        window =gtk_window_new(GTK_WINDOW_TOPLEVEL);

/*		gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER); */
		gtk_widget_set_uposition (window, 1, 1);
        gtk_signal_connect(GTK_OBJECT (window), "delete_event",GTK_SIGNAL_FUNC(salir),NULL);

        gtk_widget_set_usize(window,640,-1);
        gtk_container_border_width(GTK_CONTAINER(window),15);

        accel_group=gtk_accel_group_new();
        item_factory=gtk_item_factory_new(GTK_TYPE_MENU_BAR,"<blah>",accel_group);
        gtk_item_factory_create_items(item_factory,nmenu_items,menu_items,NULL);
		gtk_widget_show_all(window);
        gtk_accel_group_attach(accel_group,GTK_OBJECT(window));
        gtk_window_set_title(GTK_WINDOW(window),nombrefichero);
        gtk_container_border_width(GTK_CONTAINER(window),0);

        box1=gtk_vbox_new(FALSE,0);
        gtk_container_add(GTK_CONTAINER (window),box1);
        gtk_box_pack_start(GTK_BOX (box1),gtk_item_factory_get_widget(item_factory,"<blah>"),FALSE,FALSE,0);
 		CreateBar(box1);
/*		CreateText(box1); */
/*		gtk_widget_show_all(create_window1()); */
		create_window1(window,box1);
		gtk_window_set_title(GTK_WINDOW(window),"GTKdbase-seta");
        gtk_widget_show_all(window);
}


main (int argc, char *argv[])
{
   	gtk_init(&argc,&argv);
        CreateItemFactory();
	gtk_main();
	return 0;
}

gint salir (GtkWidget *widget,gpointer gdata)
{
   g_print("Terminando\n");
   gtk_main_quit();
   return (FALSE);
}


int SearchAll(int n,char *texto)
{
int z,zz;
	for(z=n;z<numreg[0];z++)
		{
		 for(zz=0;zz<totalcampos[0];zz++)
		 	{
			 if(1==compara(0,z,zz,texto))
				 {
				  yyz=zz;
				  return(z);
				 }
			}
		}
return(-1);
}

int SearchCampo(int n,int campo,char *texto)
{
int z,zz;
	for(z=n;z<numreg[0];z++)
		{
			 if(1==compara(0,z,campo,texto))
				 {
				  return(z);
				 }
		}
return(-1);
}


/* ----- Compara texto en ficha y campo, devuelve 1 si = ----- */
int compara(int numdb,int num,int campo,char *texto)
{
int z,zz;
long indi;
	if(pfdb[numdb]==0)goto fin;
	if(num<0||num>=numreg[numdb])goto fin;
	z=0;
	for(zz=0;zz<campo;zz++)z+=tamareg[zz][numdb];
	indi=primercampo[numdb]+num*(tamaregs[numdb]);
	fseek(pfdb[numdb],indi+z,0);

	 z=campo;
	 fread(buffer,1,tamareg[z][numdb],pfdb[numdb]);
	 buffer[tamareg[z][numdb]]=0;
	 ppv1=cabememo[numdb]+z*32+43;
	 if(*ppv1=='D')
			{
             strncpy(buffer+20,buffer,10);
			 strncpy(buffer,buffer+26,2);
			 buffer[2]='/';
			 strncpy(buffer+3,buffer+24,2);
			 buffer[5]='/';
			 strncpy(buffer+6,buffer+20,4);
			 buffer[10]=0;
			}
	if(NULL!=(char *)strstr(buffer,texto)) return(1); else return(0);
fin:
	return(0);
}

/* ------ ver ficha ---- */
void verficha(int num,int numdb)
{
int z,zz;
gchar *datos[1];
long indi;
	if(pfdb[numdb]==0)goto fin;
	if(num<0||num>=numreg[numdb])goto fin;
	indi=primercampo[numdb]+num*(tamaregs[numdb]);
	fseek(pfdb[numdb],indi,0);
	ppv=cabememo[numdb]+32;
	gtk_clist_clear((GtkCList *)clist1);
	for(z=0;z<totalcampos[numdb];z++)
	{
	 strncpy(VARI,ppv,32); VARI[32]=0;
	 fread(buffer,1,tamareg[z][numdb],pfdb[numdb]);
	 buffer[tamareg[z][numdb]]=0;
	 ppv1=cabememo[numdb]+z*32+43;
	 if(*ppv1=='D')
			{
             strncpy(buffer+20,buffer,10);
			 strncpy(buffer,buffer+26,2);
			 buffer[2]='/';
			 strncpy(buffer+3,buffer+24,2);
			 buffer[5]='/';
			 strncpy(buffer+6,buffer+20,4);
			 buffer[10]=0;
			}
	 datos[0]=VARI;
	 datos[1]=buffer;
	 ppv+=32;
	 gtk_clist_append( (GtkCList *) clist1 , datos);
	}
fin:
	sprintf(VARI,"%d",yy+1);
	gtk_entry_set_text (GTK_ENTRY (entry2), VARI);
	sprintf(VARI,"%d",numreg[0]);
	gtk_entry_set_text (GTK_ENTRY (entry1), VARI);
	if(verdeldb(yy,0)==42)
		gtk_entry_set_text (GTK_ENTRY (entry6), "MARCADA");
     else
		gtk_entry_set_text (GTK_ENTRY (entry6), "-------");
}

/* ---- Cierra base de datos ---- */

int closedb(int numdb)
{
	if(pfdb[numdb]!=0)
		{
		 fclose(pfdb[numdb]);
         free(cabememo[numdb]);
		 pfdb[numdb]=0;
		 cabememo[numdb]=0;
		}
}

/*---- Abre un base de datos -----*/
int opendb(char *nombre,int numdb)
{
	if((pfdb[numdb]=fopen(nombre,"r+b"))==NULL) return(-1);
	strncpy(nombredb+numdb*80,nombre,80);
    fseek(pfdb[numdb],0,2);
    tamano[numdb]=ftell(pfdb[numdb]);
	fseek(pfdb[numdb],0,0);	fread(cabecera,1,32,pfdb[numdb]);
	numreg[numdb]=cabecera[4]+cabecera[5]*255;
	printf("numero de fichas %d\n",numreg[numdb]);
	totalcampos[numdb]=0; i=32; tamaregs[numdb]=0;
volver:
	fseek(pfdb[numdb],i,0);
	fread(cabecera,1,34,pfdb[numdb]);
	z=cabecera[16];
	tamaregs[numdb]= tamaregs[numdb]+z;
	tamareg[totalcampos[numdb]][numdb]=z;
	i+=32;	totalcampos[numdb]++;
	if(cabecera[32]!=13 ) goto volver;
	tamaregs[numdb]++;
	primercampo[numdb]=i+2;
	if(cabecera[33]==0)primercampo[numdb]++;
	if(NULL==(cabememo[numdb]=(char *)malloc(primercampo[numdb]))) error(8);
	fseek(pfdb[numdb],0,0);
	fread(cabememo[numdb],primercampo[numdb],1,pfdb[numdb]);

	strncpy(VARI,nombredb,40);g_print("%s\n",VARI);
	sprintf(VARI,"Nume. campos=%d  dir.1.campo=%d  tamao base=%d fichas=%d",totalcampos[0],primercampo[0],tamano[0],numreg[numdb]);
	g_print("%s\n",VARI);
	combo1_items=NULL;
	combo1_items=g_list_append(combo1_items,"Todos");
	ppv=cabememo[numdb]+32;
	for(z=0;z<totalcampos[numdb];z++)
	{
	 strncpy(VARI,ppv,32); VARI[32]=0;
/*	 g_print(" %s\n",VARI); */
	 combo1_items=g_list_append(combo1_items,ppv);
	 ppv+=32;
	}
 	gtk_combo_set_popdown_strings (GTK_COMBO (combo1), combo1_items);
	g_list_free (combo1_items);
	yyz1=-1;

	yy=0;
	verficha(yy,0);
}

/* ---- Inserta una ficha mas ---- */
void appedb(int numdb)
{
long indi;
unsigned int z;
	fseek(pfdb[numdb],0,2);
	z=tamaregs[numdb]+1;
	for(;z>0;z--)putc(0,pfdb[numdb]);
	putc(26,pfdb[numdb]);
	numreg[numdb]++;
	tamano[numdb]+=tamaregs[numdb];
	ppv=cabememo[numdb]+4; *ppv=0x00FF&numreg[numdb];
	ppv++;	*ppv=0x00FF&(numreg[numdb]>>8);
	fseek(pfdb[numdb],4,0);
	fwrite(cabememo[numdb]+4,2,1,pfdb[numdb]);
}


/* ---- Marca la ficha con * de borrado ---- */
void deldb(int num,int numdb)
{
long indi;
	if(num<0||num>=numreg[numdb])goto fin;
	indi=primercampo[numdb]+num*(tamaregs[numdb])-1;
	fseek(pfdb[numdb],indi,0);
	fputc(42,pfdb[numdb]);
fin:
;
}
/* ---- Elimina marca de borrado ---- */
void nodeldb(int num,int numdb)
{
long indi;
	if(num<0||num>=numreg[numdb])goto fin;
	indi=primercampo[numdb]+num*(tamaregs[numdb])-1;
	fseek(pfdb[numdb],indi,0);
	fputc(32,pfdb[numdb]);
fin:
;
}
/* ---- Borra todas las fichas marcadas con * ---- */
void packdb(int numdb)
{
long indi;
unsigned int z,zz,conta;
unsigned char *ppv,*ppv1;

	if(NULL==(ppv=(char *)malloc(tamano[numdb]))){ error(8); goto fin;}
	fseek(pfdb[numdb],0,0);	fread(ppv,tamano[numdb],1,pfdb[numdb]);
	printf("Borrando fichas marcadas\n");

	conta=0; zz=numreg[numdb];
	for(z=0;z<zz;z++)
		{
		 indi=primercampo[numdb]+z*(tamaregs[numdb])-1;
		 ppv1=ppv+indi;
		 if(*ppv1==42)
			{
			 memcpy(ppv1,ppv1+tamaregs[numdb],tamaregs[numdb]*(numreg[numdb]+1));
			 conta++; zz--; z--;
			}
		}
	if(numreg[numdb]==conta)
		{
		 conta--;
		 ppv1=ppv+primercampo[numdb]-1;
		 for(z=0;z<tamaregs[numdb];z++,ppv1++){*ppv1=32;}
		 *ppv1=26;
		}
	tamano[numdb]-=conta*tamaregs[numdb];
	numreg[numdb]-=conta;
	ppv1=ppv+4; *ppv1=0x00FF&numreg[numdb];
	ppv1++;	*ppv1=0x00FF&(numreg[numdb]>>8);
	printf("borradas %d fichas \n",conta);
	closedb(numdb);
	strncpy(VARI,nombredb+80*numdb,80); VARI[79]=0;
	if((pfdb[numdb]=fopen(VARI,"w+b"))==NULL){error(2); goto fin1;}
	fseek(pfdb[numdb],0,0); fwrite(ppv,tamano[numdb],1,pfdb[numdb]);
	fclose(pfdb[numdb]);
    if(-1==opendb(VARI,numdb))error(2);
fin1:

	free(ppv);
fin:
;
}
/* ---- Ve el estado de las fichas ---- */
char verdeldb(int num,int numdb)
{
 long indi;
	if(num<0||num>=numreg[numdb])return(-1);
	indi=primercampo[numdb]+num*(tamaregs[numdb])-1;
	fseek(pfdb[numdb],indi,0);
	return(fgetc(pfdb[numdb]));
}

/*------------------------------------------------*/

void menos_button10(void)
{
	yy--;
	if(yy<0)yy=0;
	verficha(yy,0);
}
void mas_button11(void)
{
	yy++;
	if(yy>=numreg[0])yy=numreg[0]-1;
	verficha(yy,0);
}

void menos10_button8_clicked(void)
{
	yy-=10;
	if(yy<0)yy=0;
	verficha(yy,0);
}

void mas10_button9_clicked (void)
{
	yy+=10;
	if(yy>=numreg[0])yy=numreg[0]-1;
	verficha(yy,0);
}


void on_entry2_activate (void)
{
 	yy=atoi(gtk_entry_get_text(GTK_ENTRY(entry2)) );
	yy--;
	if(yy>=numreg[0])yy=numreg[0]-1;
	if(yy<0)yy=0;
 	verficha(yy,0);
}


void on_entry3_activate (void)
{
 	MenuBuscar();
}

void on_button5_clicked (void)
{
	yy=0;
	verficha(yy,0);
}


void  on_button6_clicked (void)
{
	yy=numreg[0]-1;
	verficha(yy,0);
}

void on_button20_clicked (void)
{
int numdb;
int num;
int z,zz;
gchar *datos[1];
long indi,num1;
	if(window3!=0)gtk_widget_destroy( window3);
	gtk_widget_show_all(create_window3());
	numdb=0;
	num=yy;
	if(pfdb[numdb]==0)goto fin;
	if(num<0||num>=numreg[numdb])goto fin;
	indi=primercampo[numdb]+num*(tamaregs[numdb]);
	fseek(pfdb[numdb],indi,0);
	ppv=cabememo[numdb]+32;

	for(z=0;z<totalcampos[numdb];z++)
	{
	 strncpy(VARI,ppv,32); VARI[32]=0;
	 fread(buffer,1,tamareg[z][numdb],pfdb[numdb]);
	 buffer[tamareg[z][numdb]]=0;
	 ppv1=cabememo[numdb]+z*32+43;
	 if(*ppv1=='D')
			{
             strncpy(buffer+20,buffer,10);
			 strncpy(buffer,buffer+26,2);
			 buffer[2]='/';
			 strncpy(buffer+3,buffer+24,2);
			 buffer[5]='/';
			 strncpy(buffer+6,buffer+20,4);
			 buffer[10]=0;
			}
	 if(*ppv1=='C')
			{
			 for(zz=tamareg[z][numdb]-1;zz>0 && buffer[zz]==32;zz--);
			 if(zz<tamareg[z][numdb])buffer[zz+1]=0;
			}
	 if(*ppv1=='N')
			{
			 num1=atol(buffer);
			 sprintf(buffer,"%d",num1);
			}
	 datos[0]=VARI;
	 datos[1]=buffer;
	 ppv+=32;
	entrynom[z] = gtk_entry_new ();
	gtk_entry_set_text(GTK_ENTRY(entrynom[z]),VARI);
  	gtk_widget_ref (entrynom[z]);
  	gtk_object_set_data_full (GTK_OBJECT (window3), "nombre", entrynom[z],
                            (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (entrynom[z]);
	gtk_box_pack_start (GTK_BOX (vbox12), entrynom[z], TRUE, TRUE, 0);

	gtk_entry_set_editable (GTK_ENTRY (entrynom[z]), FALSE);

	entryval[z] = gtk_entry_new_with_max_length (tamareg[z][numdb]);
	gtk_entry_set_text(GTK_ENTRY(entryval[z]),buffer);
  	gtk_widget_ref (entryval[z]);
  	gtk_object_set_data_full (GTK_OBJECT (window3), "Valor", entryval[z],
                            (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (entryval[z]);
	gtk_box_pack_start (GTK_BOX (vbox13), entryval[z], TRUE, TRUE, 0);
	}
fin:
;
}

void on_button21_clicked (void)
{
	appedb(0);
	yy=numreg[0]-1;
	verficha(yy,0);
	on_button20_clicked();
}

void on_button22_clicked (void)
{
	packdb(0);
}


void on_button23_clicked (void)
{
	deldb(yy,0);
	verficha(yy,0);
}


void on_button24_clicked (void)
{
	nodeldb(yy,0);
	verficha(yy,0);
}

/* funciones de edicion */
void on_button25_clicked(void)
{
unsigned int z,x,ta,xx,zz;
long indi;
int numdb;

	numdb=0;
	indi=primercampo[numdb]+yy*(tamaregs[numdb]);
/*	printf("Primer registro ->%d\n",indi); */
	fseek(pfdb[numdb],indi,0);
	for(z=0;z<totalcampos[numdb];z++)
	  {
		ppv=cabememo[numdb]+z*32+43;	ta=*(ppv+5);
		for(x=0;x<79;x++)VARI[x]=0;
		sprintf(VARI,"%s",gtk_entry_get_text(GTK_ENTRY(entryval[z])));
	 if(*ppv=='N')
			{
			 for(x=40;x<79;x++)if(VARI[x]<44)VARI[x]=32;
			 for(x=0;x<79;x++)if(VARI[x]>57)
				 				{
								 CuadroOk("ACERCA","Error, campo numerico con caracteres",(char *)seta_xpm);
								 goto salir;
								}
			 VARI[ta]=0;
			 xx=0;
			 for(zz=0;zz<ta;zz++) {  VARI[zz+50]=VARI[zz];  if(VARI[zz]>42)xx=zz; }
			 for(zz=0;zz<ta;zz++)  VARI[zz]=VARI[zz+51-ta+xx];
			}
	 if(*ppv=='C')
			{
			 for(x=0;x<79;x++)if(VARI[x]<32)VARI[x]=32;
			}
/*		printf("tam=%i->%s\n",ta,VARI); */
		fwrite(VARI,ta,1,pfdb[numdb]);
	  }
	gtk_widget_destroy( window3);
	verficha(yy,0);
	window3=0;
salir:
}


void on_button26_clicked (void)
{
/* NO GUARDA LO MODIFICADO */
	gtk_widget_destroy( window3);
	window3=0;
}



void on_button28_clicked  (void)
{
char *c;

	c=gtk_entry_get_text(GTK_ENTRY(combo_entry3) );
/*	printf("num de ordenacion %s  %d \n",c,yyz2); */
	if(forma==0)
		ordenardb(yyz2,0,0);
	 else
		ordenardb(yyz2,0,1);
	gtk_widget_destroy(window4);
	window4=0;
	yy=0;verficha(yy,0);
}


void on_button29_clicked (void)
{
	gtk_widget_destroy(window4);
	window4=0;
}

void on_combo_entry3_changed(void)
{
 gchar *c;
 int zz,z;
 	c=gtk_entry_get_text(GTK_ENTRY(combo_entry3));
 	ppv=cabememo[0]+32;
	for(z=0;z<totalcampos[0];z++)
	{
	 zz=strcmp(c,ppv);
	 if(zz==0){ yyz2=z; return;}
	 ppv+=32;
	}
	yyz2=0;
}

void MenuOrdenar1(void)
{
	forma=0;
	MenuOrdenar();
}
void MenuOrdenar2(void)
{
	forma=1;
	MenuOrdenar();
}
void MenuOrdenar(void)
{
	if(window4==0)	gtk_widget_show_all(create_window4());
	combo4_items=NULL;
	combo4_items=g_list_append(combo4_items,"Primer campo");
	ppv=cabememo[0]+32;
	for(z=0;z<totalcampos[0];z++)
	{
	 strncpy(VARI,ppv,32); VARI[32]=0;
	 combo4_items=g_list_append(combo4_items,ppv);
	 ppv+=32;
	}
 	gtk_combo_set_popdown_strings (GTK_COMBO (combo4), combo4_items);
	g_list_free (combo4_items);
}

/* -ordena una base de datos por el campo num -*/
/* -forma 0=ascendente , 1=descendente- */
void ordenardb(int num,int numdb,int forma)
{
long indi;
unsigned int z,zz,ta,tipo,z1;
unsigned int x,y,yy;
unsigned char *ppv,*ppv0,*ppv1,*ppv2;
long num1,num2;
	ppv1=cabememo[numdb]+num*32+43;
	if(*ppv1=='N'){tipo=1; printf("Ordenacion numerico\n");} else printf("Ordenacion alfanumerica\n");
	ta=tamaregs[numdb];

	if(NULL==(ppv0=(char *)malloc(ta))){ error(8); goto fin;}
	if(NULL==(ppv=(char *)malloc(tamano[numdb]))){ error(8); goto fin0;}
	fseek(pfdb[numdb],0,0);	fread(ppv,tamano[numdb],1,pfdb[numdb]);
	printf("Campo %d  - Tipo=%d (0=ascendente-1=descendente)\n",num,forma);

	z=0; z1=0;
	for(zz=0;zz<num;zz++)z+=tamareg[zz][numdb];
	zz=numreg[numdb];
	for(x=0;x<zz;x++)
		{
		 z1++;
		 if(z1>500) { z1=0; printf("Ordenando ficha %d\n",x); }
		 ppv1=ppv+primercampo[numdb]+x*ta+z;
		 for(y=0;y<zz;y++)
		 	{
			 ppv2=ppv+primercampo[numdb]+y*ta+z;
			 if(tipo==1)
				 {
					 yy=tamareg[num][numdb];
					 memcpy(VARI,ppv1,yy); VARI[yy]=0; num1=atol(VARI);
					 memcpy(VARI,ppv2,yy); VARI[yy]=0; num2=atol(VARI);
					 if(forma==0)
						{
					 	 if(num1<num2)
				 				{
							 	 memcpy(ppv0,ppv2-z,ta);
							 	 memcpy(ppv2-z,ppv1-z,ta);
								 memcpy(ppv1-z,ppv0,ta);
								}
						}
						else
						{
						 if(num1>num2)
				 				{
							 	 memcpy(ppv0,ppv2-z,ta);
							 	 memcpy(ppv2-z,ppv1-z,ta);
								 memcpy(ppv1-z,ppv0,ta);
								}
						}

				 }
				else
				 {
				  if(forma==0)
				 	{
				  	if(0>memcmp(ppv1,ppv2,tamareg[num][numdb]))
				 		{
							memcpy(ppv0,ppv2-z,ta);
							memcpy(ppv2-z,ppv1-z,ta);
							memcpy(ppv1-z,ppv0,ta);
						}
					}
					else
					{
					 if(0<memcmp(ppv1,ppv2,tamareg[num][numdb]))
				 		{
							memcpy(ppv0,ppv2-z,ta);
							memcpy(ppv2-z,ppv1-z,ta);
							memcpy(ppv1-z,ppv0,ta);
						}
					}
				 }
			}
		}

	fseek(pfdb[numdb],0,0);	fwrite(ppv,tamano[numdb],1,pfdb[numdb]);
fin1:
	free(ppv);
fin0:
	free(ppv0);
fin:
;
}

void on_guardar(void)
{

int y=5,z,num;
FILE *pf;
gchar *p;
char *nombre;
char campo[11][NUMCAMPOS];
char tipo[NUMCAMPOS];
unsigned int tamano[NUMCAMPOS];
unsigned int decimales[NUMCAMPOS];
unsigned int zz,z1;
char VARI[80];

	nombre=(gchar *)gtk_entry_get_text(GTK_ENTRY(entry4));
	g_print("Creando fichero  %s  \n",nombre);
	if((pf=fopen(nombre,"w+b"))==NULL)
		{CuadroOk("ERROR SALVANDO"," No se ha podido crear el fichero        ",(char *)xpm_exit);goto salir;}
	for(z=0;z<NUMCAMPOS;z++)
		{
/* TAMAO */
		 gtk_clist_get_text(GTK_CLIST(clist2), z, 2, &p);
		 tamano[z]=atoi(p);
		 if(tamano[z]==0) break;
/* TIPO **/
		 gtk_clist_get_text(GTK_CLIST(clist2), z, 1, &p);
		 if(0==strncmp(p,"Lgico"))tipo[z]='L';
		 if(0==strncmp(p,"Fecha"))tipo[z]='D';
		 if(0==strncmp(p,"Texto"))tipo[z]='C';
	 	 if(0==strncmp(p,"Nmero"))tipo[z]='N';
/* DECIMALES */
		 gtk_clist_get_text(GTK_CLIST(clist2), z, 3, &p);
		 decimales[z]=atoi(p);
/* NOMBRE */
		 gtk_clist_get_text(GTK_CLIST(clist2), z, 0, &p);
		 for(zz=0;zz<12;zz++)campo[zz][z]=0;
		 for(zz=0;zz<11&&*p!=0;zz++,p++){campo[zz][z]=*p; g_print("%c",*p);}
		 g_print("\nTamao=%d Decimales=%d  Tipo=%c  \n",tamano[z],decimales[z],tipo[z]);
		}
	num=z;
	g_print("\nNumero de campos= %d ",num);
	putc(3,pf);
	/* fecha */
	putc(0,pf);
	putc(0,pf);
	putc(0,pf);
	/* numero de fichas por defecto 1 */
	putc(1,pf);
	putc(0,pf);
	putc(0,pf);
	putc(0,pf);
	/* direccin de primer campo */
	zz=(num+1)*32+1;
	putc((zz&0x00ff),pf);
	putc(((zz>>8)&0x00ff),pf);
	/* tamao de ficha */
	zz=1;
	for(z=0;z<num;z++){zz+=tamano[z]+decimales[z];	}
	z1=zz;
	putc((zz&0x00ff),pf);
	putc(((zz>>8)&0x00ff),pf);
	/* 20 bytes con cero */
	for(z=0;z<20;z++)putc(0,pf);
	/* cabecera de ficha, tamao 32 */
	for(zz=0;zz<num;zz++)
	{
	  /* nombre 10 caracteres y un cero */
	  for(z=0;z<11;z++)putc(campo[z][zz],pf);
	  /* tipo c/n/d/l */
	  putc(tipo[zz],pf);
	  /* ----xxxx---- */
	  putc(0,pf);
	  putc(0,pf);
	  putc(0,pf);
	  putc(0,pf);
	  /* tamao de la ficha */
	  putc(tamano[zz],pf);
	  /* numero de decimales */
	  putc(decimales[zz],pf);
	  /* 14 bytes reservados */
	  for(z=0;z<14;z++)putc(0,pf);
	}
	/* finaliza con un 13 */
	putc(13,pf);
	/* crea la primer ficha en blanco */
	for(z=0;z<z1;z++)putc(32,pf);
	/* termina con el caracter 26 */
	putc(26,pf);
	fclose(pf);
	on_salir();
salir:
;
}
void on_salir(void)
{
	gtk_widget_destroy( window2);
}
void on_aceptar(void)
{
	gchar *borra;
	gchar *datos[4];

	datos[0]=gtk_entry_get_text(GTK_ENTRY(entry5) );
	datos[1]=gtk_entry_get_text(GTK_ENTRY(combo_entry2) );
	if(0==strncmp(datos[1],"Lgico")||0==strncmp(datos[1],"Fecha") )
		{
		 if(0==strncmp(datos[1],"Lgico"))datos[2]="1"; else datos[2]="8";
		}
		else
		{
		 datos[2]=gtk_entry_get_text(GTK_ENTRY(spinbutton2) );
		}
	if(0==strncmp(datos[1],"Nmero"))
			datos[3]=gtk_entry_get_text(GTK_ENTRY(spinbutton3) );
		else
			datos[3]="0";
	gtk_clist_append( (GtkCList *) clist2 , datos);
}
void on_borrar(void)
{
	gtk_clist_remove( (GtkCList *)clist2,(gint) zrow);
}


void on_row( GtkWidget *clist,gint row,gint column,GdkEventButton *event, gpointer data )
{
	zrow=row;
	return;
}


void MenuAbout(void)
{
	CuadroOk("ACERCA","GTK-DBASE",(char *)seta_xpm);
}


void CreateBar(GtkWidget *container)
{
	toolbar=gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL,GTK_TOOLBAR_ICONS);
	gtk_box_pack_start(GTK_BOX(container),toolbar,FALSE,TRUE,0);

	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),NULL,"Nuevo",NULL,
						CreateWidgetFromXpm(window,(gchar**)xpm_new),
						(GtkSignalFunc)MenuNew,NULL);
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),NULL,"Abrir fichero",NULL,
						CreateWidgetFromXpm(window,(gchar**)xpm_open),
						(GtkSignalFunc)MenuLoad,NULL);
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),NULL,"Guardar",NULL,
						CreateWidgetFromXpm(window,(gchar**)xpm_save),
						(GtkSignalFunc)MenuSave,NULL);
	gtk_toolbar_append_space( GTK_TOOLBAR(toolbar) );

	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),NULL,"Salir",NULL,
						CreateWidgetFromXpm(window,(gchar**)xpm_exit),
 						(GtkSignalFunc)salirmenu,NULL);
	gtk_widget_show(toolbar);
}

GtkWidget *CreateWidgetFromXpm(GtkWidget *win,gchar **xpm_data)
{
 GdkBitmap *mask;
 GdkPixmap *pixmap_data;
 GtkWidget *pixmap_widget;


 	pixmap_data=gdk_pixmap_create_from_xpm_d(window->window,&mask,NULL,xpm_data);
/*	g_print("------------\n"); */
	pixmap_widget=gtk_pixmap_new(pixmap_data,mask);
	gtk_widget_show(pixmap_widget);
	return(pixmap_widget);
}

void CreateText(GtkWidget *container)
{
 GtkWidget *table,*vscrollbar;
		table=gtk_table_new(2,2,FALSE);
		gtk_container_add(GTK_CONTAINER(container),table);

		text=gtk_text_new(NULL,NULL);
		gtk_text_set_editable(GTK_TEXT(text),TRUE);
		gtk_table_attach(GTK_TABLE(table),text,0,1,0,1,
							GTK_EXPAND|GTK_SHRINK|GTK_FILL,
							GTK_EXPAND|GTK_SHRINK|GTK_FILL,0,0);
		gtk_widget_show(text);
		vscrollbar=gtk_vscrollbar_new(GTK_TEXT(text)->vadj);
		gtk_table_attach(GTK_TABLE(table),vscrollbar,1,2,0,1,GTK_FILL,GTK_EXPAND|GTK_SHRINK|GTK_FILL,0,0);
}

void SaveAsOk( GtkWidget *w, GtkFileSelection *fs)
{

}


void on_Siguiente_clicked(void)
{
 int z;
 char *c;
	c=gtk_entry_get_text(GTK_ENTRY(entry3) );
	if(yyz1==-1)
	{
	 if(-1==(z=SearchAll(yy+1,c)))
		{
		 CuadroOk("Buscar","No se encuentran ninguno",NULL);
		}
		else
		{
		 yy=z;
		 verficha(yy,0);
		 gtk_clist_select_row((GtkCList *)clist1,yyz,0);
		}
	}
	else
	{
	 if(-1==(z=SearchCampo(yy+1,yyz1,c)))
		{
		 CuadroOk("Buscar en campo","       No se encuentran ninguno     ",NULL);
		}
		else
		{
		 yy=z;
		 verficha(yy,0);
		 gtk_clist_select_row((GtkCList *)clist1,yyz1,0);
		}
	}
}


void on_combo_entry1_changed(void)
{
 gchar *c;
 int zz,z;
 	c=gtk_entry_get_text(GTK_ENTRY(combo_entry1));
 	ppv=cabememo[0]+32;
	for(z=0;z<totalcampos[0];z++)
	{
	 zz=strcmp(c,ppv);
	 if(zz==0){ yyz1=z; return;}
	 ppv+=32;
	}
	yyz1=-1;
}


void on_Buscar_clicked(void)
{
 MenuBuscar();
}

void on_ebuscar_activate(void)
{
 MenuBuscar();
}

void MenuMiMa(void)
{
	MinuMayu(0);
	verficha(yy,0);
}

/* Cambia minusculas a mayusculas
 tambien quita acentos tipo windows y los pone a mayusculas */
void MinuMayu(int numdb)
{
unsigned int x;
unsigned char *ppv,*ppv0;
long num1,num2;

	if(NULL==(ppv=(char *)malloc(tamano[numdb]))){ error(8); goto fin;}
	fseek(pfdb[numdb],0,0);	fread(ppv,tamano[numdb],1,pfdb[numdb]);
	printf("Cambiando Minusculas a Mayusculas\n");
	ppv0=ppv+primercampo[numdb];
	for(x=primercampo[numdb];x<tamano[numdb];x++,ppv0++)
		{
		  switch(*ppv0)
		 	{
			case 181:  *ppv0='A'; break;
			case 144:  *ppv0='E'; break;
			case 214:  *ppv0='I'; break;
			case 224:  *ppv0='O'; break;
			case 233:  *ppv0='U'; break;
			case 160:  *ppv0='A'; break;
			case 130:  *ppv0='E'; break;
			case 161:  *ppv0='I'; break;
			case 162:  *ppv0='O'; break;
			case 163:  *ppv0='U'; break;
			case 164:  *ppv0=''; break;
			case 165:  *ppv0=''; break;
			default:
			if(*ppv0>96 && *ppv0<123)*ppv0=*ppv0-32;
		 	}
		}

	fseek(pfdb[numdb],0,0);	fwrite(ppv,tamano[numdb],1,pfdb[numdb]);
fin1:
	free(ppv);
fin:
;
}
void MenuBuscar(void)
{
 int z;
 char *c;
	c=gtk_entry_get_text(GTK_ENTRY(entry3) );
 if(yyz1==-1)
	{
	 if(-1==(z=SearchAll(0,c)))
		{
/*		 g_print("no existe ninguno igual"); */
		 CuadroOk("Buscar","No se encuentran ninguno",NULL);
		}
		else
		{
		 yy=z;
		 verficha(yy,0);
		 gtk_clist_select_row((GtkCList *)clist1,yyz,0);
		}
	}
	else
	{
	 if(-1==(z=SearchCampo(0,yyz1,c)))
		{
		 CuadroOk("Buscar en campo","       No se encuentran ninguno    ",NULL);
		}
		else
		{
		 yy=z;
		 verficha(yy,0);
		 gtk_clist_select_row((GtkCList *)clist1,yyz1,0);
		}
	}
}

void MenuNew(void)
{
	gtk_widget_show_all(create_window2());
}

void MenuLoad(void)
{
	filew = gtk_file_selection_new ("Abrir fichero");
	gtk_widget_set_uposition (filew, 8, 8);
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
			"clicked", (GtkSignalFunc) LoadOk,filew );
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
			"clicked", (GtkSignalFunc) gtk_widget_destroy,GTK_OBJECT (filew));
    gtk_widget_show(filew);
}

void MenuSave(void)
{
}

void CopiaDia(void)
{
FILE *pf;
time_t tiempo;
struct  tm *ptime;
int numdb,z;
unsigned char *ppv;
char vari[80];
		strcpy(vari,nombredb);
		z=strlen(vari);vari[z-4]=0;
		numdb=0;
 		tiempo=time(NULL);
		ptime=localtime(&tiempo);
		sprintf(VARI,"%s_%d_%d_%d.dbf",vari,(*ptime).tm_mday,(*ptime).tm_mon+1,(*ptime).tm_year+1900 );

		if(NULL==(ppv=(char *)malloc(tamano[numdb]))){ error(8); goto fin;}
		fseek(pfdb[numdb],0,0);	fread(ppv,tamano[numdb],1,pfdb[numdb]);
		if((pf=fopen(VARI,"w+b"))==NULL){error(2); goto fin1;}
		fseek(pf,0,0); fwrite(ppv,tamano[numdb],1,pf);
		fclose(pf);
		CuadroOk("HECHA COPIA DE SEGURIDAD DEL DIA ",VARI,(char *)seta_xpm);
fin1:
		free(ppv);
fin:
;
}

void LoadOk( GtkWidget *w, GtkFileSelection *fs)
{
 int z;
 char *nombre;
 	nombre= gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));
	g_print ("Funcion file_ok_sel->%s\n", nombre);
	strcpy(nombrefichero,nombre);

	z=strlen(nombre);
	if('d'!=*(nombre+z-3)||'b'!=*(nombre+z-2)||'f'!=*(nombre+z-1))
		{
		 CuadroOk("LOAD","ERROR.El fichero no es .dbf",(char *)xpm_exit);
		 goto salto;
		}
	gtk_window_set_title(GTK_WINDOW(window),nombrefichero);
	closedb(0);
	gtk_clist_clear((GtkCList *)clist1);
	if(-1==opendb(nombre,0))
		{
		 CuadroOk("LOAD","ERROR en fichero",(char *)xpm_exit);
	   	}
salto:
	gtk_widget_destroy(filew);
}


void CuadroOk(char *titulo,char *texto, char *imagen)
{
 GtkWidget *window,*button,*pixmapwid;
 static GtkWidget *label;

	window=gtk_dialog_new();
	gtk_signal_connect(GTK_OBJECT(window),"destroy",GTK_SIGNAL_FUNC(CloseDialogo),window);
	gtk_window_set_title(GTK_WINDOW(window),titulo);
	gtk_widget_set_usize (window,400,200 );
	gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
	gtk_container_border_width(GTK_CONTAINER(window),5);
	if(imagen!=NULL)
	{
	 pixmapwid=CreateWidgetFromXpm(window,(gchar**)imagen);
	 gtk_box_pack_start (GTK_BOX (GTK_DIALOG(window)->vbox),pixmapwid, FALSE, FALSE, 3);
	 gtk_widget_show(pixmapwid);
	}

	label=gtk_label_new(texto);
	gtk_misc_set_padding(GTK_MISC(label),10,10);
	gtk_box_pack_start(GTK_BOX (GTK_DIALOG(window)->vbox),label,TRUE,TRUE,0);


	gtk_widget_show(label);

	button=gtk_button_new_with_label("OK");
	gtk_signal_connect(GTK_OBJECT(button),"clicked",GTK_SIGNAL_FUNC(CloseDialogo),window);
	GTK_WIDGET_SET_FLAGS(button,GTK_CAN_DEFAULT);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->action_area),button,TRUE,TRUE,0);
	gtk_widget_grab_default(button);
	gtk_widget_show(button);
	gtk_widget_show(window);
	gtk_grab_add(window);
}

void CloseDialogo(GtkWidget *widget,gpointer data)
{
	gtk_widget_destroy(GTK_WIDGET(data));
}


